#!/bin/bash

source ~/auto-key/scripts/.autokeyfunctions
clear

while [ 1 ]
do
    ShowKeysMenu
    read CHOICE
    case "$CHOICE" in

        #CHOICE 1
        
        "1")
            clear
            cd
            cd ~/auto-key/scripts/
            ./makeprivate.sh
            clear
            ;;

        #CHOICE 2
        
        "2")
            clear
            cd
            cd ~/auto-key/scripts/
            if [[ -e ~/auto-key/keys/new_private_keys/e-0x3/releasekey.x509.pem ]] || [[ -e ~/auto-key/keys/new_private_keys/e-0x3/releasekey.pk8 ]];
            then  
                cat ~/auto-key/scripts/text/viewpublic.txt ;
                read -p "Press [Enter] to continue..."
                clear
                openssl x509 -in ~/auto-key/keys/new_private_keys/e-0x3/releasekey.x509.pem -text
                read -p "Press [Enter] to continue..."
                clear           
            else

                cat ~/auto-key/scripts/text/makefirst.txt ;
                read -p "Press [Enter] to continue..."
                clear
            fi;
            ;;

        #CHOICE 3
        
        
        "3")
            clear
            cd
            cd ~/auto-key/scripts/
            if [[ -e ~/auto-key/keys/new_private_keys/e-0x10001/releasekey.x509.pem ]] || [[ -e ~/auto-key/keys/new_private_keys/e-0x10001/releasekey.pk8 ]];
            then  
                cat ~/auto-key/scripts/text/viewpublic.txt ;
                read -p "Press [Enter] to continue..."
                clear
                openssl x509 -in ~/auto-key/keys/new_private_keys/e-0x10001/releasekey.x509.pem -text
                read -p "Press [Enter] to continue..."
                clear           
            else

                cat ~/auto-key/scripts/text/makefirst.txt ;
                read -p "Press [Enter] to continue..."
                clear
            fi;
            ;;

        #CHOICE 4

        "4")
            clear
            cd
            cd ~/auto-key/scripts/
            ./factoryKeyMenu.sh
            clear

            ;;

        #CHOICE 5

        "5")
            clear
            cd
            cd ~/auto-key/scripts/
            if [[ -e ~/auto-key/keys/factorykey/releasekey.x509.pem ]];
            then
                rm -f file ~/auto-key/keys/factorykey/factoryex.txt
                openssl x509 -in ~/auto-key/keys/factorykey/releasekey.x509.pem -text > ~/auto-key/keys/factorykey/factoryex.txt
                clear
                factoryexponent="Exponent:"
                factoryexponent2=$(grep "$factoryexponent" ~/auto-key/keys/factorykey/factoryex.txt);
                factoryexponent3="$(echo -e "${factoryexponent2}" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')"
                echo ""
                echo "Please Note That the Factory Key Uses" 
                echo "${factoryexponent3}"
                echo ""
                echo "THE /res/keys FILE WE WILL MAKE WILL USE"
                echo "${factoryexponent3} of your Private Keys"
                echo ""
                echo "!!! ANY ZIP YOU SIGN FOR THIS DEVICE !!!"
                echo "MUST USE ${factoryexponent3} of your Private Keys"
                echo "OR THE SIGNATURE VERIFICATION WILL FAIL"
                echo ""
                echo ""
                read -p "Press [Enter] to continue..."
            else
                clear
                cat ~/auto-key/scripts/text/makeotafirst.txt ;
                read -p "Press [Enter] to continue..."
                clear

            fi;

            #testing offset value of factory key
            mkdir -p -v ~/auto-key/keys/res/e-0x3;
            mkdir -p -v ~/auto-key/keys/res/e-0x10001;

            factoryexponent4="Exponent: 3 (0x3)"
            factoryexponent5="Exponent: 65537 (0x10001)"

            if [[ ${factoryexponent3} == ${factoryexponent4} ]];
            then
                cd
                cd ~/auto-key/scripts/dump-key
                java -cp .:./bcprov-jdk15on-153.jar com.android.dumpkey.DumpPublicKey ~/auto-key/keys/new_private_keys/e-0x3/releasekey.x509.pem > ~/auto-key/keys/res/e-0x3/keys
                clear
                cat ~/auto-key/scripts/text/reskeydump.txt;
                read -p "Press [Enter] to continue..."
                clear   

            elif [[ ${factoryexponent3} == ${factoryexponent5} ]];
            then 
                cd
                cd ~/auto-key/scripts/dump-key
                java -cp .:./bcprov-jdk15on-153.jar com.android.dumpkey.DumpPublicKey ~/auto-key/keys/new_private_keys/e-0x10001/releasekey.x509.pem > ~/auto-key/keys/res/e-0x10001/keys
                clear
                cat ~/auto-key/scripts/text/reskeydump.txt;
                read -p "Press [Enter] to continue..."
                clear

            else
                clear
                cat ~/auto-key/scripts/text/wrongoffset.txt ;
                read -p "Press [Enter] to continue..."
                clear
                exit
            fi;

            ;;

        "99")
            clear
            exit
            ;;


    esac

done
exit

