#!/bin/bash

source ~/auto-key/scripts/.autokeyfunctions

clear

while [ 1 ]
do
    ShowRecoveryMenu
    read CHOICE
    case "$CHOICE" in

	#CHOICE 1
        
        "1")
            clear
            cd
            cd ~/auto-key/scripts/
            cat ~/auto-key/scripts/text/requirements.txt ;
            read -p "Press [Enter] to continue..."
            clear
            ./testadb.sh
            if [[ ${adbfound} == no ]]; then
                clear
                cat ~/auto-key/scripts/text/adbnotfound.txt ;
                read -p "Press [Enter] to continue..."
                clear 
                exit
            else
                clear
                mkdir -p -v ~/auto-key/device/backup/recovery;
                cd
                cd ~/auto-key/logs/;
                rm -f file ~/auto-key/logs/path1.txt;
                rm -f file ~/auto-key/logs/path2.txt;
                rm -f file ~/auto-key/logs/path3.txt;
                rm -f file ~/auto-key/logs/path4.txt;
                rm -f file ~/auto-key/logs/mountpoints.txt;
                rm -f file ~/auto-key/logs/recpart.txt;
                rm -f file ~/auto-key/logs/recpart1.txt;
                rm -f file ~/auto-key/logs/recpart2.txt;
                rm -f file ~/auto-key/scripts/ddcomand.sh;
                rm -f file ~/auto-key/device/backup/recovery/recovery.img;

                #GETTING VARIABLE DEVICE PATHS
                frnpath="/dev/block/platform";
                endpath="by-name";
                adb devices;
                adb -d shell 'ls -l /dev/block/platform/ | grep ^d'> path1.txt;
                clear
                #strip to first line
                read -r varpath < path1.txt
                #output 1st line to file
                echo "$varpath" > path2.txt
                #output last word in file
                blkname=$(sed -n '${s/.* //; p}' path2.txt);

                echo "$blkname" > path3.txt
                tr -d '\r' < path3.txt > path4.txt
                blkname1=`cat path4.txt`

                pullpath=$(echo "ls -al ${frnpath}/${blkname1}/${endpath}");
                adb -d shell $pullpath > mountpoints.txt

                #GETTING VARIABLE DEVICE PARTITION INFO
                recblock="recovery"
                recblock2=$(grep "$recblock" ~/auto-key/logs/mountpoints.txt);
                echo "$recblock2" | tr '[/]' ' ' > recpart.txt
                #output last word in file
                recname=$(sed -n '${s/.* //; p}' recpart.txt);
                echo "$recname" > recpart1.txt
                tr -d '\r' < recpart1.txt > recpart2.txt
                recname1=`cat recpart2.txt`
                ddp1="adb -d shell su -c 'dd if=/dev/block"
                ddp2="of=/storage/sdcard1/download/recovery.img'"
                ddpath="$ddp1/$recname1 $ddp2"
                cp ~/auto-key/scripts/container/ddcomand.sh ~/auto-key/scripts/ 
                cd
                cd ~/auto-key/scripts/
                echo $ddpath >> ddcomand.sh
                echo "ready to copy recovery.img to /storage/sdcard1/download"
                echo "this should be your internal storage"
                read -p "Press [Enter] to continue..."
                ./ddcomand.sh
                adb pull -p /storage/sdcard1/download/recovery.img ~/auto-key/device/backup/recovery/recovery.img
                adb shell rm /storage/sdcard1/download/recovery.img
                read -p "Press [Enter] to continue..."

                clear
            fi; 

            cd
            if [[ -e ~/auto-key/device/backup/recovery/recovery.img ]]; then 
                clear
                cat ~/auto-key/scripts/text/recoveryfound.txt ;
                read -p "Press [Enter] to continue..."
                clear 
            else
                cat ~/auto-key/scripts/text/recoverysd.txt ;
                read -p "Press [Enter] to continue..."
                clear  
            fi;

	    ;;

	#CHOICE 2
        
        "2")
            clear
            cd
            cd ~/auto-key/scripts/

            read -p "Press [Enter] to continue..."
            clear           
	    ;;

	#CHOICE 3
        
        
        "3")
            clear
            cd
            cd ~/auto-key/scripts/

            read -p "Press [Enter] to continue..."
            clear

	    ;;

	#CHOICE 4 GET RECOVERY IMAGE INFO

        "4")
            clear
            cd
            cd ~/auto-key/scripts/
	    clear
            cat ~/auto-key/scripts/text/recinfo.txt ;
            read -p "Press [Enter] to continue..." 

		if [[ -e ~/auto-key/device/backup/recovery/recovery.img ]]; then 
	    		clear
			image=~/auto-key/device/backup/recovery/recovery.img
			pagesz=`od -A n -D -j 36 -N 4 $image | sed 's/ //g'`
			commline=`od -A n --strings -j 64 -N 512 $image`
			rdisk_la=`od -A n -H -j 20 -N 4 $image | sed 's/ //g'`
			loadadd=0x$rdisk_la
			basetail=0000
			base=`od -A n -h -j 14 -N 2 $image | sed 's/ //g'`
			base1=0x$base$basetail
			echo "PAGE SIZE: $pagesz"
			echo "BASE ADDRESS: $base1"
			echo "RAMDISK ADDRESS: $loadadd"
			echo "CMDLINE: '$commline'"
			echo " "
			read -p "Press [Enter] to continue..."
		else
			clear
            		cat ~/auto-key/scripts/text/recnoexsist.txt ;
           	        read -p "Press [Enter] to continue..."
		fi;

            clear

	    ;;

	#CHOICE 5

        "5")
            clear
            cd
            cd ~/auto-key/scripts/
	    clear
            cat ~/auto-key/scripts/text/unpakrd.txt ;
            read -p "Press [Enter] to continue..."

		if [[ -e ~/auto-key/device/backup/recovery/recovery.img ]]; then 
	    		clear
			rm -rf ~/auto-key/ramdisk;
			mkdir -p -v ~/auto-key/ramdisk;
			mkdir -p -v ~/auto-key/ramdisk/ramdisk;
			cd
			cd ~/auto-key/ramdisk/
			~/auto-key/scripts/unmkbootimg ~/auto-key/device/backup/recovery/recovery.img > ramdisk_info.txt
			clear
			echo "this is the unmkbootimg info"
			cat ~/auto-key/ramdisk/ramdisk_info.txt
			read -p "Press [Enter] to continue..."
			clear
			cd
			cd ~/auto-key/ramdisk/ramdisk/
			gunzip -c ~/auto-key/ramdisk/initramfs.cpio.gz | cpio -i
			clear
            		cat ~/auto-key/scripts/text/ramdiskextok.txt ;
           	        read -p "Press [Enter] to continue..."

		else
			clear
            		cat ~/auto-key/scripts/text/recnoexsist.txt ;
           	        read -p "Press [Enter] to continue..."
		fi;

            clear
            
	    ;;

	#CHOICE 6

        "6")
            clear
            cd
            cd ~/auto-key/scripts/
            clear
		if [[ -e ~/auto-key/device/backup/recovery/recovery.img ]] && [[ -e ~/auto-key/keys/res/e-0x3/keys ]] || [[ -e ~/auto-key/device/backup/recovery/recovery.img ]] && [[ -e ~/auto-key/keys/res/e-0x10001/keys ]]; then 
	    		clear
            		cat ~/auto-key/scripts/text/redytopatch.txt ;			
           	        read -p "Press [Enter] to continue..."
			cd
			cd ~/auto-key/logs/
			cat ~/auto-key/ramdisk/ramdisk/res/keys > ramdiskexp.txt
			read -r key < ramdiskexp.txt
			echo $key > ramdiskexp1.txt
			key1=`cat ramdiskexp1.txt`
			keyexp=$(echo $key1 | cut -d" " -f1);
			echo $keyexp
				if [[ ${keyexp} == v2 ]]; then
				   rm -f file ~/auto-key/ramdisk/ramdisk/res/keys;
   				   cp ~/auto-key/keys/res/e-0x10001/keys ~/auto-key/ramdisk/ramdisk/res/
				else
				   rm -f file ~/auto-key/ramdisk/ramdisk/res/keys;
   				   cp ~/auto-key/keys/res/e-0x3/keys ~/auto-key/ramdisk/ramdisk/res/
				fi;
				echo "finished patching"
           	        read -p "Press [Enter] to continue..."




		elif [[ -e ~/auto-key/device/backup/recovery/recovery.img ]]; then
			clear
            		cat ~/auto-key/scripts/text/recnokeyxsist.txt;
           	        read -p "Press [Enter] to continue..."

		elif [[ -e ~/auto-key/keys/res/e-0x3/keys ]] || [[ -e ~/auto-key/keys/res/e-0x10001/keys ]]; then
			clear
            		cat ~/auto-key/scripts/text/recnoexsist.txt;
           	        read -p "Press [Enter] to continue..."

		fi;

            clear
	    ;;

        "99")
            clear
            exit
            ;;


    esac

done
exit

